Index: branches/2013/dev_r3987_UKMO6_C1D/NEMOGCM/NEMO/OPA_SRC/C1D/c1d.F90
===================================================================
--- branches/2013/dev_r3987_UKMO6_C1D/NEMOGCM/NEMO/OPA_SRC/C1D/c1d.F90	(revision 4134)
+++ branches/2013/dev_r3987_UKMO6_C1D/NEMOGCM/NEMO/OPA_SRC/C1D/c1d.F90	(revision 4144)
@@ -4,16 +4,26 @@
    !! Ocean domain  :  1D configuration
    !!=====================================================================
-   !! History :   2.0  !  2004-09  (C. Ethe)  Original code
-   !!             3.0  !  2008-04 (G. Madec)  adaptation to SBC
+   !! History :   2.0  !  2004-09 (C. Ethe)     Original code
+   !!             3.0  !  2008-04 (G. Madec)    adaptation to SBC
+   !!             3.5  !  2013-10 (D. Calvert)  add namelist
    !!----------------------------------------------------------------------
+#if defined key_c1d
+   !!----------------------------------------------------------------------
+   !!   'key_c1d'                                   1D column configuration
+   !!----------------------------------------------------------------------
+   !!   c1d_init       : read in the C1D namelist
+   !!----------------------------------------------------------------------
+   USE in_out_manager   ! I/O manager
+   USE par_kind         ! kind parameters
 
    IMPLICIT NONE
    PRIVATE
 
-#if defined key_c1d
-   LOGICAL, PUBLIC, PARAMETER ::   lk_c1d = .TRUE.    !: 1D config. flag activated
-#else
-   LOGICAL, PUBLIC, PARAMETER ::   lk_c1d = .FALSE.   !: 1D config. flag de-activated
-#endif
+   PUBLIC   c1d_init                                 ! called by nemogcm.F90
+
+   LOGICAL , PUBLIC, PARAMETER ::  lk_c1d = .TRUE.   ! 1D config. flag
+
+   REAL(wp), PUBLIC            ::  rn_lat = 50       ! Column latitude
+   REAL(wp), PUBLIC            ::  rn_lon = -145     ! Column longitude
 
    !!----------------------------------------------------------------------
@@ -22,3 +32,45 @@
    !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!======================================================================
+CONTAINS
+
+   SUBROUTINE c1d_init
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE c1d_init  ***
+      !! 
+      !! ** Purpose :   Initialization of C1D options
+      !!
+      !! ** Method  :   Read namelist namc1d 
+      !!----------------------------------------------------------------------
+      NAMELIST/namc1d/ rn_lat, rn_lon
+      !!----------------------------------------------------------------------
+      !
+      REWIND ( numnam )               ! Read C1D options from namelist
+      READ   ( numnam, namc1d )
+      !
+      IF(lwp) THEN                    ! Control print
+         WRITE(numout,*)
+         WRITE(numout,*) 'c1d_init : Initialize 1D model configuration options'
+         WRITE(numout,*) '~~~~~~~~'
+         WRITE(numout,*) '   Namelist namc1d : set options for the C1D model'
+         WRITE(numout,*) '      column latitude                 rn_lat = ', rn_lat
+         WRITE(numout,*) '      column longitude                rn_lon = ', rn_lon
+      ENDIF
+      !
+      !
+   END SUBROUTINE c1d_init
+
+#else
+   !!----------------------------------------------------------------------
+   !!   Dummy module :                           No use of 1D configuration
+   !!----------------------------------------------------------------------
+   LOGICAL, PUBLIC, PARAMETER ::   lk_c1d = .FALSE.   !: 1D config. flag de-activated
+   REAL                       ::   rn_lat, rn_lon
+CONTAINS
+
+   SUBROUTINE c1d_init               ! Dummy routine
+   END SUBROUTINE c1d_init
+
+#endif
+
+   !!======================================================================
 END MODULE c1d
Index: branches/2013/dev_r3987_UKMO6_C1D/NEMOGCM/NEMO/OPA_SRC/C1D/domc1d.F90
===================================================================
--- branches/2013/dev_r3987_UKMO6_C1D/NEMOGCM/NEMO/OPA_SRC/C1D/domc1d.F90	(revision 4144)
+++ branches/2013/dev_r3987_UKMO6_C1D/NEMOGCM/NEMO/OPA_SRC/C1D/domc1d.F90	(revision 4144)
@@ -0,0 +1,208 @@
+MODULE domc1d
+   !!======================================================================
+   !!                     ***  MODULE  domc1d  ***
+   !! Ocean Domain : 1D column position from lat/lon namelist specification
+   !!======================================================================
+   !! History :  3.5  !  2013-04  (D. Calvert)  Original code
+   !!----------------------------------------------------------------------
+#if defined key_c1d
+   !!----------------------------------------------------------------------
+   !!   'key_c1d'   :                                      1D Configuration
+   !!----------------------------------------------------------------------
+   !!   dom_c1d     : Determine jpizoom/jpjzoom from a given lat/lon
+   !!----------------------------------------------------------------------
+   USE phycst                        ! Physical constants (and par_oce)
+   USE iom                           ! I/O library (iom_get)
+   USE in_out_manager                ! I/O manager (ctmp1)
+   USE dom_oce , ONLY : nimpp, njmpp ! Shared/distributed memory setting (mpp_init routine)
+   USE wrk_nemo                      ! Memory allocation
+   USE timing                        ! Timing
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC   dom_c1d                  ! Routine called in domcfg.F90
+
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id: domc1d.F90 3851 2013-04-30 10:30:51Z hadcv $ 
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+CONTAINS
+   
+   SUBROUTINE dom_c1d( plat, plon )
+      !!----------------------------------------------------------------------
+      !!                   ***  ROUTINE dom_c1d  ***
+      !! 
+      !! ** Purpose : Recalculate jpizoom/jpjzoom indices from lat/lon point
+      !!
+      !! ** Method  : Calculate global gphit and glamt as for dom_hgr.
+      !!              After, find closest grid point to lat/lon point as for 
+      !!              dom_ngb on T grid. From this infer jpizoom and jpjzoom.
+      !!
+      !! ** Action  : Recalculate jpizoom, jpjzoom (indices of C1D zoom)
+      !!----------------------------------------------------------------------
+      INTEGER  ::  ji, jj                          ! Dummy loop indices
+      INTEGER  ::  inum                            ! Coordinate file handle (case 0)
+      INTEGER  ::  ijeq                            ! Index of equator T point (case 4)
+
+      INTEGER , DIMENSION(2) ::   iloc             ! Minloc returned indices
+
+      REAL(wp), INTENT(in) ::  plat                ! Column latitude
+      REAL(wp), INTENT(in) ::  plon                ! Column longitude
+
+      REAL(wp) ::  zlon                            ! Wraparound longitude
+      REAL(wp) ::  zti, ztj, zarg                  ! Local scalars
+      REAL(wp) ::  glam0, gphi0                    ! Variables corresponding to parameters ppglam0 ppgphi0 set in par_oce
+      REAL(wp) ::  zlam1, zcos_alpha, ze1, ze1deg  ! Case 5 local scalars
+      REAL(wp) ::  zphi1, zsin_alpha, zim05, zjm05 !          "
+
+      REAL(wp) , POINTER, DIMENSION(:,:) ::  gphidta, glamdta, zdist ! Global lat/lon
+      !!----------------------------------------------------------------------
+
+      IF( nn_timing == 1 )   CALL timing_start('dom_c1d')
+
+      CALL wrk_alloc( jpidta, jpjdta, gphidta, glamdta, zdist )
+
+
+      ! ============================= !
+      !  Code from dom_hgr:           !
+      !  Calculate global horizontal  !
+      !  mesh, only glamt and gphit   !
+      ! ============================= !
+
+      SELECT CASE( jphgr_msh )   ! type of horizontal mesh
+
+      CASE ( 0 )                 !  curvilinear coordinate on the sphere read in coordinate.nc file
+
+         CALL iom_open( 'coordinates', inum )
+         CALL iom_get( inum, jpdom_unknown, 'glamt', glamdta ) ! mig, mjg undefined at this point
+         CALL iom_get( inum, jpdom_unknown, 'gphit', gphidta ) ! so use jpdom_unknown not jpdom_data
+         CALL iom_close ( inum )
+
+         PRINT *,'Check dom_c1d coordinates file data read in:' !!!
+         PRINT *,'Bottom-left most glamdta is ', glamdta(1,1)    !!! Need to check
+         PRINT *,'Bottom-left most gphidta is ', gphidta(1,1)    !!! field read
+         PRINT *,'We are using nimpp,njmpp = ' , nimpp,njmpp     !!!
+
+      CASE ( 1 )                 ! geographical mesh on the sphere with regular grid-spacing
+
+         DO jj = 1, jpjdta
+            DO ji = 1, jpidta
+               zti = FLOAT( ji - 1 + nimpp - 1 )
+               ztj = FLOAT( jj - 1 + njmpp - 1 )
+
+               glamdta(ji,jj) = ppglam0 + ppe1_deg * zti
+               gphidta(ji,jj) = ppgphi0 + ppe2_deg * ztj
+            END DO
+         END DO
+
+      CASE ( 2:3 )               ! f- or beta-plane with regular grid-spacing
+         
+         glam0 = 0.e0
+         gphi0 = - ppe2_m * 1.e-3
+
+         DO jj = 1, jpjdta
+            DO ji = 1, jpidta
+               glamdta(ji,jj) = glam0 + ppe1_m * 1.e-3 * FLOAT( ji - 1 + nimpp - 1 )
+               gphidta(ji,jj) = gphi0 + ppe2_m * 1.e-3 * FLOAT( jj - 1 + njmpp - 1 )
+            END DO
+         END DO
+
+      CASE ( 4 )                 ! geographical mesh on the sphere, isotropic MERCATOR type
+
+         IF( ppgphi0 == -90 )   CALL ctl_stop( ' Mercator grid cannot start at south pole !!!! ' )
+
+         zarg = rpi / 4. - rpi / 180. * ppgphi0 / 2.
+         ijeq = ABS( 180. / rpi * LOG( COS( zarg ) / SIN( zarg ) ) / ppe1_deg )
+         IF( ppgphi0 > 0 )   ijeq = -ijeq
+
+         DO jj = 1, jpjdta
+            DO ji = 1, jpidta
+               zti = FLOAT( ji - 1    + nimpp - 1 )
+               ztj = FLOAT( jj - ijeq + njmpp - 1 )
+
+               glamdta(ji,jj) = ppglam0 + ppe1_deg * zti
+               gphidta(ji,jj) = 1. / rad * ASIN ( TANH( ppe1_deg * rad * ztj ) )
+            END DO
+         END DO
+
+      CASE ( 5 )                 ! beta-plane with regular grid-spacing and rotated domain (GYRE configuration)
+   
+         zlam1 = -85
+         zphi1 = 29
+         ze1 = 106000. / FLOAT(jp_cfg)
+ 
+         zsin_alpha = - SQRT( 2. ) / 2.
+         zcos_alpha =   SQRT( 2. ) / 2.
+         ze1deg = ze1 / (ra * rad)
+
+         glam0 = zlam1 + zcos_alpha * ze1deg * FLOAT( jpjdta-2 ) ! Force global
+         gphi0 = zphi1 + zsin_alpha * ze1deg * FLOAT( jpjdta-2 )
+
+         DO jj = 1, jpjdta
+            DO ji = 1, jpidta
+               zim05 = FLOAT( ji + nimpp - 1 ) - 1.5
+               zjm05 = FLOAT( jj + njmpp - 1 ) - 1.5
+
+               glamdta(ji,jj) = glam0 + zim05 * ze1deg * zcos_alpha + zjm05 * ze1deg * zsin_alpha
+               gphidta(ji,jj) = gphi0 - zim05 * ze1deg * zsin_alpha + zjm05 * ze1deg * zcos_alpha
+            END DO
+         END DO
+
+      CASE DEFAULT
+
+         WRITE(ctmp1,*) '          bad flag value for jphgr_msh = ', jphgr_msh
+         CALL ctl_stop( ctmp1 )
+
+      END SELECT
+
+
+      ! ============================== !
+      !  Code from dom_ngb:            !
+      !  Calculate the nearest grid    !
+      !  point to the given lat/lon &  !
+      !  update jpizoom and jpjzoom    !
+      ! ============================== !
+
+      zlon         = MOD( plon         + 720., 360. )                                      ! plon    between    0 and 360
+      glamdta(:,:) = MOD( glamdta(:,:) + 720., 360. )                                      ! glamdta between    0 and 360
+      IF( zlon > 270. )   zlon = zlon - 360.                                               ! zlon    between  -90 and 270
+      IF( zlon <  90. )   WHERE( glamdta(:,:) > 180. ) glamdta(:,:) = glamdta(:,:) - 360.  ! glamdta between -180 and 180
+
+      glamdta(:,:) = glamdta(:,:) - zlon
+      gphidta(:,:) = gphidta(:,:) - plat
+      zdist(:,:)   = glamdta(:,:) * glamdta(:,:) + gphidta(:,:) * gphidta(:,:)
+      
+      iloc(:) = MINLOC( zdist(:,:) ) ! No mask; zoom indices freely defined
+      jpizoom = iloc(1) + nimpp - 2  ! Minloc index - 1; want the bottom-left
+      jpjzoom = iloc(2) + njmpp - 2  ! corner index of the zoom domain.
+
+      CALL wrk_dealloc( jpidta, jpjdta, gphidta, glamdta, zdist )
+
+      IF (lwp) THEN
+         WRITE(numout,*)
+         WRITE(numout,*) 'dom_c1d : compute jpizoom & jpjzoom from global mesh and given coordinates'
+         WRITE(numout,*) '~~~~~~~'
+         WRITE(numout,*) '      column i zoom index             jpizoom = ', jpizoom
+         WRITE(numout,*) '      column j zoom index             jpjzoom = ', jpjzoom
+         WRITE(numout,*)
+      ENDIF
+
+      IF( nn_timing == 1 )   CALL timing_stop('dom_c1d')
+
+   END SUBROUTINE dom_c1d
+
+#else
+   !!----------------------------------------------------------------------
+   !!   Default option                                  NO 1D Configuration
+   !!----------------------------------------------------------------------
+CONTAINS  
+   SUBROUTINE dom_c1d( plat, plon )     ! Empty routine
+      REAL :: plat, plon
+      WRITE(*,*) 'dom_c1d: You should not have seen this print! error?',plat,plon
+   END SUBROUTINE dom_c1d
+#endif
+
+   !!======================================================================
+END MODULE domc1d
Index: branches/2013/dev_r3987_UKMO6_C1D/NEMOGCM/NEMO/OPA_SRC/C1D/dtauvd.F90
===================================================================
--- branches/2013/dev_r3987_UKMO6_C1D/NEMOGCM/NEMO/OPA_SRC/C1D/dtauvd.F90	(revision 4144)
+++ branches/2013/dev_r3987_UKMO6_C1D/NEMOGCM/NEMO/OPA_SRC/C1D/dtauvd.F90	(revision 4144)
@@ -0,0 +1,263 @@
+MODULE dtauvd
+   !!======================================================================
+   !!                     ***  MODULE  dtauvd  ***
+   !! Ocean data  :  read ocean U & V current data from gridded data
+   !!======================================================================
+   !! History :  3.5   ! 2013-08  (D. Calvert)  Original code
+   !!----------------------------------------------------------------------
+
+   !!----------------------------------------------------------------------
+   !!   dta_uvd_init   : read namelist and allocate data structures
+   !!   dta_uvd        : read and time-interpolate ocean U & V current data
+   !!----------------------------------------------------------------------
+   USE oce             ! ocean dynamics and tracers
+   USE dom_oce         ! ocean space and time domain
+   USE fldread         ! read input fields
+   USE in_out_manager  ! I/O manager
+   USE phycst          ! physical constants
+   USE lib_mpp         ! MPP library
+   USE wrk_nemo        ! Memory allocation
+   USE timing          ! Timing
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC   dta_uvd_init   ! called by nemogcm.F90
+   PUBLIC   dta_uvd        ! called by istate.F90 and dyndmp.90
+
+   LOGICAL , PUBLIC ::   ln_uvd_init   = .FALSE.      ! Flag to initialise with U & V current data
+   LOGICAL , PUBLIC ::   ln_uvd_dyndmp = .FALSE.      ! Flag for Newtonian damping toward U & V current data
+
+   TYPE(FLD), ALLOCATABLE, DIMENSION(:) ::   sf_uvd   ! structure for input U & V current (file information and data)
+
+   !! * Substitutions
+#  include "domzgr_substitute.h90"
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id: dtauvd.F90 2392 2010-11-15 21:20:05Z gm $ 
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+CONTAINS
+
+   SUBROUTINE dta_uvd_init( ld_dyndmp )
+      !!----------------------------------------------------------------------
+      !!                   ***  ROUTINE dta_uvd_init  ***
+      !!                    
+      !! ** Purpose :   initialization of U & V current input data 
+      !! 
+      !! ** Method  : - read namc1d_uvd namelist
+      !!              - allocate U & V current data structure
+      !!              - fld_fill data structure with namelist information
+      !!----------------------------------------------------------------------
+      LOGICAL, INTENT(in), OPTIONAL ::   ld_dyndmp         ! force the initialization when dyndmp is used
+      !
+      INTEGER ::   ierr0, ierr1, ierr2, ierr3              ! temporary integers
+      !
+      CHARACTER(len=100)            ::   cn_dir            ! Root directory for location of files to be used
+      TYPE(FLD_N), DIMENSION(2)     ::   suv_i             ! Combined U & V namelist information
+      TYPE(FLD_N)                   ::   sn_ucur, sn_vcur  ! U & V data namelist information
+      !!
+      NAMELIST/namc1d_uvd/ ln_uvd_init, ln_uvd_dyndmp, cn_dir, sn_ucur, sn_vcur
+      !!----------------------------------------------------------------------
+      !
+      IF( nn_timing == 1 )  CALL timing_start('dta_uvd_init')
+      !
+      ierr0 = 0  ;  ierr1 = 0  ;  ierr2 = 0  ;  ierr3 = 0
+      !
+      cn_dir = './'                 ! default: directory in which the model is executed
+      !
+      !                             !==   read namelist namc1d_uvd: flags and field info   ==!
+
+      !                             ! default values (NB: frequency positive => hours, negative => months)
+      !              !   file   ! frequency ! variable  ! time intep !  clim   ! 'yearly' or ! weights  ! rotation !
+      !              !   name   !  (hours)  !  name     !   (T/F)    !  (T/F)  !  'monthly'  ! filename ! pairs    !
+      sn_ucur = FLD_N( 'ucurrent',   -1     , 'u_current',  .false.  , .true.  ,  'monthly'  , ''       , 'Ume'    )
+      sn_vcur = FLD_N( 'vcurrent',   -1     , 'v_current',  .false.  , .true.  ,  'monthly'  , ''       , 'Vme'    )
+
+      REWIND( numnam )              ! Read in namelist namc1d_uvd
+      READ  ( numnam, namc1d_uvd )
+
+      !                             ! force the initialization when dyndmp is used
+      IF( PRESENT( ld_dyndmp ) )   ln_uvd_dyndmp = .TRUE.
+      
+      IF(lwp) THEN                  ! control print
+         WRITE(numout,*)
+         WRITE(numout,*) 'dta_uvd_init : U & V current data '
+         WRITE(numout,*) '~~~~~~~~~~~~ '
+         WRITE(numout,*) '   Namelist namc1d_uvd : Set flags'
+         WRITE(numout,*) '      Initialization of ocean U & V current with input data   ln_uvd_init   = ', ln_uvd_init
+         WRITE(numout,*) '      Damping of ocean U & V current toward input data        ln_uvd_dyndmp = ', ln_uvd_dyndmp
+         WRITE(numout,*)
+         IF( .NOT. ln_uvd_init .AND. .NOT. ln_uvd_dyndmp ) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) '   U & V current data not used'
+         ENDIF
+      ENDIF
+      !                             ! no initialization when restarting
+      IF( ln_rstart .AND. ln_uvd_init ) THEN
+         CALL ctl_warn( 'dta_uvd_init: ocean restart and U & V current data initialization, ',   &
+            &           'we keep the restart U & V current values and set ln_uvd_init to FALSE' )
+         ln_uvd_init = .FALSE.
+      ENDIF
+
+      !
+      IF(  ln_uvd_init .OR. ln_uvd_dyndmp  ) THEN
+         !                          !==   allocate the data arrays   ==!
+         ALLOCATE( sf_uvd(2), STAT=ierr0 )
+         IF( ierr0 > 0 ) THEN
+            CALL ctl_stop( 'dta_uvd_init: unable to allocate sf_uvd structure' )             ;   RETURN
+         ENDIF
+         !
+                                 ALLOCATE( sf_uvd(1)%fnow(jpi,jpj,jpk)   , STAT=ierr0 )
+         IF( sn_ucur%ln_tint )   ALLOCATE( sf_uvd(1)%fdta(jpi,jpj,jpk,2) , STAT=ierr1 )
+                                 ALLOCATE( sf_uvd(2)%fnow(jpi,jpj,jpk)   , STAT=ierr2 )
+         IF( sn_vcur%ln_tint )   ALLOCATE( sf_uvd(2)%fdta(jpi,jpj,jpk,2) , STAT=ierr3 )
+         !
+         IF( ierr0 + ierr1 + ierr2 + ierr3 > 0 ) THEN
+            CALL ctl_stop( 'dta_uvd_init : unable to allocate U & V current data arrays' )   ;   RETURN
+         ENDIF
+         !                          !==   fill sf_uvd with sn_ucur, sn_vcur and control print   ==!
+         suv_i(1) = sn_ucur   ;   suv_i(2) = sn_vcur
+         CALL fld_fill( sf_uvd, suv_i, cn_dir, 'dta_uvd', 'U & V current data', 'namc1d_uvd' )
+         !
+      ENDIF
+      !
+      IF( nn_timing == 1 )  CALL timing_stop('dta_uvd_init')
+      !
+   END SUBROUTINE dta_uvd_init
+
+
+   SUBROUTINE dta_uvd( kt, puvd )
+      !!----------------------------------------------------------------------
+      !!                   ***  ROUTINE dta_uvd  ***
+      !!                    
+      !! ** Purpose :   provides U & V current data at time step kt
+      !! 
+      !! ** Method  : - call fldread routine
+      !!              - ORCA_R2: make some hand made alterations to the data (EMPTY)
+      !!              - s- or mixed s-zps coordinate: vertical interpolation onto model mesh
+      !!              - zps coordinate: vertical interpolation onto last partial level
+      !!              - ln_uvd_dyndmp=False: deallocate the U & V current data structure,
+      !!                                     as the data is no longer used
+      !!
+      !! ** Action  :   puvd,  U & V current data interpolated onto model mesh at time-step kt
+      !!----------------------------------------------------------------------
+      INTEGER                           , INTENT(in   ) ::   kt     ! ocean time-step
+      REAL(wp), DIMENSION(jpi,jpj,jpk,2), INTENT(  out) ::   puvd   ! U & V current data
+      !
+      INTEGER ::   ji, jj, jk, jl, jkk               ! dummy loop indicies
+      INTEGER ::   ik, il0, il1, ii0, ii1, ij0, ij1  ! local integers
+      REAL(wp)::   zl, zi                            ! local floats
+      REAL(wp), POINTER, DIMENSION(:) ::  zup, zvp   ! 1D workspace
+      !!----------------------------------------------------------------------
+      !
+      IF( nn_timing == 1 )  CALL timing_start('dta_uvd')
+      !
+      CALL fld_read( kt, 1, sf_uvd )      !==   read U & V current data at time step kt   ==!
+      !
+      !
+      !                                   !==   ORCA_R2 configuration and U & V current damping   ==! 
+      IF( cp_cfg == "orca" .AND. jp_cfg == 2 .AND. ln_uvd_dyndmp ) THEN    ! some hand made alterations
+         !!! EMPTY- to be added for running in 3D context !!!
+      ENDIF
+      !
+      puvd(:,:,:,1) = sf_uvd(1)%fnow(:,:,:)                 ! NO mask
+      puvd(:,:,:,2) = sf_uvd(2)%fnow(:,:,:) 
+      !
+      IF( ln_sco ) THEN                   !==   s- or mixed s-zps-coordinate   ==!
+         !
+         CALL wrk_alloc( jpk, zup, zvp )
+         !
+         IF( kt == nit000 .AND. lwp )THEN
+            WRITE(numout,*)
+            WRITE(numout,*) 'dta_uvd: interpolate U & V current data onto the s- or mixed s-z-coordinate mesh'
+         ENDIF
+         !
+         DO jj = 1, jpj                   ! vertical interpolation of U & V current:
+            DO ji = 1, jpi                ! determines the interpolated U & V current profiles at each (i,j) point
+               DO jk = 1, jpk
+                  zl = fsdept_0(ji,jj,jk)
+                  IF    ( zl < gdept_0(1  ) ) THEN          ! extrapolate above the first level of data
+                     zup(jk) =  puvd(ji,jj,1    ,1)
+                     zvp(jk) =  puvd(ji,jj,1    ,2)
+                  ELSEIF( zl > gdept_0(jpk) ) THEN          ! extrapolate below the last level of data
+                     zup(jk) =  puvd(ji,jj,jpkm1,1)
+                     zvp(jk) =  puvd(ji,jj,jpkm1,2)
+                  ELSE                                      ! inbetween : vertical interpolation between jkk & jkk+1
+                     DO jkk = 1, jpkm1                      ! when  gdept(jkk) < zl < gdept(jkk+1)
+                        IF( (zl-gdept_0(jkk)) * (zl-gdept_0(jkk+1)) <= 0._wp ) THEN
+                           zi = ( zl - gdept_0(jkk) ) / (gdept_0(jkk+1)-gdept_0(jkk))
+                           zup(jk) = puvd(ji,jj,jkk,1) + ( puvd(ji,jj,jkk+1,1 ) - puvd(ji,jj,jkk,1) ) * zi 
+                           zvp(jk) = puvd(ji,jj,jkk,2) + ( puvd(ji,jj,jkk+1,2 ) - puvd(ji,jj,jkk,2) ) * zi
+                        ENDIF
+                     END DO
+                  ENDIF
+               END DO
+               DO jk = 1, jpkm1           ! apply mask
+                  puvd(ji,jj,jk,1) = zup(jk) * umask(ji,jj,jk)
+                  puvd(ji,jj,jk,2) = zvp(jk) * vmask(ji,jj,jk)
+               END DO
+               puvd(ji,jj,jpk,1) = 0._wp
+               puvd(ji,jj,jpk,2) = 0._wp
+            END DO
+         END DO
+         ! 
+         CALL wrk_dealloc( jpk, zup, zvp )
+         ! 
+      ELSE                                !==   z- or zps- coordinate   ==!
+         !                             
+         puvd(:,:,:,1) = puvd(:,:,:,1) * umask(:,:,:)       ! apply mask
+         puvd(:,:,:,2) = puvd(:,:,:,2) * vmask(:,:,:)
+         !
+         IF( ln_zps ) THEN                ! zps-coordinate (partial steps) interpolation at the last ocean level
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  ik = mbkt(ji,jj) 
+                  IF( ik > 1 ) THEN
+                     zl = ( gdept_0(ik) - fsdept_0(ji,jj,ik) ) / ( gdept_0(ik) - gdept_0(ik-1) )
+                     puvd(ji,jj,ik,1) = (1.-zl) * puvd(ji,jj,ik,1) + zl * puvd(ji,jj,ik-1,1)
+                     puvd(ji,jj,ik,2) = (1.-zl) * puvd(ji,jj,ik,2) + zl * puvd(ji,jj,ik-1,2)
+                  ENDIF
+               END DO
+            END DO
+         ENDIF
+         !
+      ENDIF
+      !
+      IF( lwp .AND. kt == nit000 ) THEN   ! control print
+         WRITE(numout,*) ' U current '
+         WRITE(numout,*)
+         WRITE(numout,*)'  level = 1'
+         CALL prihre( puvd(:,:,1    ,1), jpi, jpj, 1, jpi, 20, 1, jpj, 20, 1., numout )
+         WRITE(numout,*)'  level = ', jpk/2
+         CALL prihre( puvd(:,:,jpk/2,1), jpi, jpj, 1, jpi, 20, 1, jpj, 20, 1., numout )
+         WRITE(numout,*)'  level = ', jpkm1
+         CALL prihre( puvd(:,:,jpkm1,1), jpi, jpj, 1, jpi, 20, 1, jpj, 20, 1., numout )
+         WRITE(numout,*)
+         WRITE(numout,*) ' V current '
+         WRITE(numout,*)
+         WRITE(numout,*)'  level = 1'
+         CALL prihre( puvd(:,:,1    ,2), jpi, jpj, 1, jpi, 20, 1, jpj, 20, 1., numout )
+         WRITE(numout,*)'  level = ', jpk/2
+         CALL prihre( puvd(:,:,jpk/2,2), jpi, jpj, 1, jpi, 20, 1, jpj, 20, 1., numout )
+         WRITE(numout,*)'  level = ', jpkm1
+         CALL prihre( puvd(:,:,jpkm1,2), jpi, jpj, 1, jpi, 20, 1, jpj, 20, 1., numout )
+         WRITE(numout,*)
+      ENDIF
+      !
+      IF( .NOT. ln_uvd_dyndmp    ) THEN   !==   deallocate U & V current structure   ==! 
+         !                                !==   (data used only for initialization)  ==!
+         IF(lwp) WRITE(numout,*) 'dta_uvd: deallocate U & V current arrays as they are only used to initialize the run'
+                                   DEALLOCATE( sf_uvd(1)%fnow )     ! U current arrays in the structure
+         IF( sf_uvd(1)%ln_tint )   DEALLOCATE( sf_uvd(1)%fdta )
+                                   DEALLOCATE( sf_uvd(2)%fnow )     ! V current arrays in the structure
+         IF( sf_uvd(2)%ln_tint )   DEALLOCATE( sf_uvd(2)%fdta )
+                                   DEALLOCATE( sf_uvd         )     ! the structure itself
+      ENDIF
+      !
+      IF( nn_timing == 1 )  CALL timing_stop('dta_uvd')
+      !
+   END SUBROUTINE dta_uvd
+
+   !!======================================================================
+END MODULE dtauvd
